VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmVisu 
   Caption         =   "DXF Visualisateur"
   ClientHeight    =   9165
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   11565
   Icon            =   "frmBrowser.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   9165
   ScaleWidth      =   11565
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picControls 
      Align           =   4  'Align Right
      Height          =   9165
      Left            =   8805
      ScaleHeight     =   9105
      ScaleWidth      =   2700
      TabIndex        =   1
      Top             =   0
      Width           =   2760
      Begin VB.Frame frmLayer 
         Caption         =   "Layer"
         Height          =   4215
         Left            =   120
         TabIndex        =   7
         Top             =   4800
         Width           =   2535
         Begin MSComctlLib.TreeView TreeViewLayer 
            Height          =   3855
            Left            =   120
            TabIndex        =   8
            Top             =   240
            Width           =   2295
            _ExtentX        =   4048
            _ExtentY        =   6800
            _Version        =   393217
            Style           =   7
            Appearance      =   1
         End
      End
      Begin VB.Frame frameAffichage 
         Caption         =   "Affichage"
         Height          =   975
         Left            =   120
         TabIndex        =   5
         Top             =   3840
         Width           =   2535
         Begin VB.OptionButton optMouse 
            BackColor       =   &H00C0C0C0&
            Height          =   615
            Index           =   0
            Left            =   50
            MaskColor       =   &H00FFFFFF&
            Picture         =   "frmBrowser.frx":030A
            Style           =   1  'Graphical
            TabIndex        =   12
            ToolTipText     =   "Pan"
            Top             =   240
            Width           =   615
         End
         Begin VB.OptionButton optMouse 
            BackColor       =   &H00C0C0C0&
            Height          =   615
            Index           =   1
            Left            =   650
            MaskColor       =   &H00FFFFFF&
            Picture         =   "frmBrowser.frx":0379
            Style           =   1  'Graphical
            TabIndex        =   11
            ToolTipText     =   "Magnify"
            Top             =   240
            Width           =   615
         End
         Begin VB.CommandButton cmdZoomIn 
            BackColor       =   &H00C0C0C0&
            Height          =   615
            Left            =   1250
            Picture         =   "frmBrowser.frx":03DF
            Style           =   1  'Graphical
            TabIndex        =   10
            Top             =   240
            Width           =   615
         End
         Begin VB.CommandButton cmdZoomOut 
            BackColor       =   &H00C0C0C0&
            Height          =   615
            Left            =   1850
            Picture         =   "frmBrowser.frx":0447
            Style           =   1  'Graphical
            TabIndex        =   9
            Top             =   240
            Width           =   615
         End
         Begin VB.OptionButton optMouse 
            Caption         =   "Center"
            Height          =   255
            Index           =   4
            Left            =   3600
            TabIndex        =   6
            Top             =   240
            Width           =   855
         End
      End
      Begin VB.DriveListBox Disque 
         Height          =   315
         Left            =   120
         TabIndex        =   4
         Top             =   120
         Width           =   2535
      End
      Begin VB.DirListBox Repertoire 
         Height          =   1665
         Left            =   120
         TabIndex        =   3
         Top             =   480
         Width           =   2535
      End
      Begin VB.FileListBox Fichier 
         Height          =   1650
         Left            =   120
         Pattern         =   "*.dxf"
         TabIndex        =   2
         Top             =   2160
         Width           =   2535
      End
   End
   Begin VB.PictureBox VisuDXF 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   9000
      Left            =   0
      ScaleHeight     =   122.131
      ScaleLeft       =   -5
      ScaleMode       =   0  'User
      ScaleTop        =   -95
      ScaleWidth      =   118.852
      TabIndex        =   0
      Top             =   0
      Width           =   8760
   End
End
Attribute VB_Name = "frmVisu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Base de donnes corrrespondant au contenu du fichier DXF

Dim BdDXF As DXFDonnee

Dim DragX As Long
Dim DragY As Long

Dim SelGroup As RECT
Dim Deplace As Boolean
Dim Zoom As Boolean
Dim SvgDeplace As Boolean
Dim SvgZoom As Boolean

Sub ReAfficheDXF(Optional Layer As String)
' affichage dans le controle ''VisuDXF de la base de donnes ''VisuDXF
 AfficheDXF VisuDXF, BdDXF, Layer
End Sub
'Diminue le facteur de Zomm de 25%
Private Sub cmdZoomIn_Click()
    VisuDXF.ScaleHeight = 0.75 * VisuDXF.ScaleHeight
    VisuDXF.ScaleWidth = 0.75 * VisuDXF.ScaleWidth
    ReAfficheDXF
End Sub
'Augmente le facteur de Zomm de 25%
Private Sub cmdZoomOut_Click()
    VisuDXF.ScaleHeight = 1.25 * VisuDXF.ScaleHeight
    VisuDXF.ScaleWidth = 1.25 * VisuDXF.ScaleWidth
    ReAfficheDXF
End Sub

Private Sub Repertoire_Change()
    Fichier.Path = Repertoire.Path
End Sub

Private Sub Disque_Change()
    Repertoire.Path = Disque.Drive
End Sub

Private Sub Fichier_Click()
Dim I As Integer

ImportDXF Fichier.Path & "\" & Fichier.FileName, BdDXF


Call VisuDxf_DblClick

On Error Resume Next
TreeViewLayer.Nodes.Clear
TreeViewLayer.Nodes.Add , tvwLast, "LAYER", "Affichage des Layers "
TreeViewLayer.Nodes.Item(1).Expanded = True

' liste les layers
For I = 0 To UBound(MonLayer)
TreeViewLayer.Nodes.Add "LAYER", tvwChild, "Layer" & I, MonLayer(I).Nom
Next I


End Sub

'Redimensionne la fenetre

Private Sub Form_Resize()
On Error GoTo Fin
    VisuDXF.Height = Me.ScaleHeight - 50
    VisuDXF.Width = Me.ScaleWidth - (50 + picControls.Width)
Fin:
End Sub


Private Sub optMouse_MouseUp(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
Select Case Index

Case 0
    If SvgDeplace Then
      optMouse(0).Value = False
      SvgDeplace = False
    Else
     SvgDeplace = True
    End If


Case 1
    If SvgZoom Then
      optMouse(1).Value = False
      SvgZoom = False
    Else
     SvgZoom = True
    End If
End Select
End Sub

'AutoCentrer en double cliquant sur le fichier
Private Sub VisuDxf_DblClick()

Dim P0 As Point2
Dim P1 As Point2
Dim P2 As Point2


Dim A As Double
Dim B As Double
Dim C As Double
Dim D As Double
 
Deplace = False
Zoom = False


Call XYZmax(P1, P2, 0, 0, 1, 1, 0)


'P0.X = P1.X + (P2.X - P1.X) / 2
'P0.Y = P1.Y + (P2.Y - P1.Y) / 2


'A = Abs(P2.X - P1.X)
'B = Abs(P2.Y - P1.Y)

'A = Distance(P1, P2) '/ 2
'B = Distance(P1, P2) / 2
'C = Distance(P1, P0)
'D = Distance(P0, P2)

'VisuDXF.Scale (-C, -D)-(D, C)

C = Abs(P2.X - P1.X) + 30
D = Abs(P2.Y - P1.Y) + 30

If C > D Then
A = C
Else
A = D
End If

B = VisuDXF.Height / VisuDXF.Width

    VisuDXF.ScaleWidth = A
    VisuDXF.ScaleLeft = P1.X - 15
    VisuDXF.ScaleHeight = A * B
    VisuDXF.ScaleTop = -P2.Y - 15
    'Debug.Print B
    'Debug.Print VisuDXF.ScaleHeight / VisuDXF.ScaleWidth
        
optMouse(0).Value = False
optMouse(1).Value = False

ReAfficheDXF

End Sub
Private Sub minmax(PoMini As Point2, PoMaxi As Point2, X As Double, Y As Double)
        If X < PoMini.X Then PoMini.X = X
        If Y < PoMini.Y Then PoMini.Y = Y

        If X > PoMaxi.X Then PoMaxi.X = X
        If Y > PoMaxi.Y Then PoMaxi.Y = Y
End Sub

'Recherche les valeurs XYZ max pour un centrage auto
Private Sub XYZmax(PoMini As Point2, PoMaxi As Point2, ByVal cX As Double, ByVal cY As Double, ByVal EchelleX As Double, ByVal EchelleY As Double, ByVal Angle As Double)
On Error Resume Next
Dim Couleur As Long
Dim Depart As Long
Dim X1 As Double
Dim Y1 As Double
Dim X2 As Double
Dim Y2 As Double
Dim X3 As Double
Dim Y3 As Double
Dim Angle1 As Double
Dim Angle2 As Double
Dim Angle3 As Double
Dim Ratio As Double
Dim rad As Double
Dim PCount As Integer
Dim Text As String
Dim Size As Double
Dim Nom As String
Dim EndPoly As Boolean



    PoMaxi.X = -INFINITY
    PoMaxi.Y = -INFINITY
    
    PoMini.X = INFINITY
    PoMini.Y = INFINITY


For Depart = 0 To UBound(BdDXF.Entite)

Select Case BdDXF.Entite(Depart).Type
    Case "LINE"
        'Rcupre les valeurs
        X1 = BdDXF.Entite(Depart).Donnee(0).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        X2 = BdDXF.Entite(Depart).Donnee(2).Valeur
        Y2 = BdDXF.Entite(Depart).Donnee(3).Valeur
        'Facteur d'chelle  des entites selon leur origine
        X1 = X1 * EchelleX
        Y1 = Y1 * EchelleY
        X2 = X2 * EchelleX
        Y2 = Y2 * EchelleY
        'Rotation des entites selon leur origine
        If Angle <> 0 Then
            X3 = RotationX(X1, Y1, Angle)
            Y3 = RotationY(X1, Y1, Angle)
            X1 = X3
            Y1 = Y3
            X3 = RotationX(X2, Y2, Angle)
            Y3 = RotationY(X2, Y2, Angle)
            X2 = X3
            Y2 = Y3
        End If
        'Dplace l'origine
        X1 = X1 + cX
        Y1 = Y1 + cY
        X2 = X2 + cX
        Y2 = Y2 + cY
        
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        Call minmax(PoMini, PoMaxi, X2, Y2)
       
    Case "ARC"
        ' Les cercles et les lignes deviennent automatiquement des ellipses quant on leur applique un facteur d'chelle
        X1 = BdDXF.Entite(Depart).Donnee(0).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        rad = BdDXF.Entite(Depart).Donnee(2).Valeur
        Angle1 = BdDXF.Entite(Depart).Donnee(3).Valeur
        Angle2 = BdDXF.Entite(Depart).Donnee(4).Valeur
        X1 = X1 * EchelleX
        Y1 = Y1 * EchelleY
        ''Si le facteur d'echelle suivant X est diffrent de Y alors
        'L 'arc ou le cercle devient une ellipse
        If EchelleX <> 1 Then
            rad = rad * EchelleX
        ElseIf EchelleY <> 1 Then
            rad = rad * EchelleY
        End If
        If Angle <> 0 Then
            X3 = RotationX(X1, Y1, Angle)
            Y3 = RotationY(X1, Y1, Angle)
            X1 = X3
            Y1 = Y3
        End If
        If EchelleX < 0 Or EchelleY < 0 Then
            ' L'arc subie une transformation mirroir
            Intervertir Angle1, Angle2
            Angle1 = 180 - Angle1
            Angle2 = 180 - Angle2
        End If
        Angle1 = Angle1 + (Angle * 180 / PI)
        Angle2 = Angle2 + (Angle * 180 / PI)
        X1 = X1 + cX
        Y1 = Y1 + cY
        
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        
    Case "CIRCLE"
        ' Les cercles et les lignes deviennent automatiquement des ellipses quant on leur applique un facteur d'chelle
        X1 = BdDXF.Entite(Depart).Donnee(0).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        rad = BdDXF.Entite(Depart).Donnee(2).Valeur
        X1 = X1 * EchelleX
        Y1 = Y1 * EchelleY
        If EchelleX <> 1 Then
            rad = rad * EchelleX
        ElseIf EchelleY <> 1 Then
            rad = rad * EchelleY
        End If
        If Angle <> 0 Then
            X3 = RotationX(X1, Y1, Angle)
            Y3 = RotationY(X1, Y1, Angle)
            X1 = X3
            Y1 = Y3
        End If
        X1 = X1 + cX
        Y1 = Y1 + cY
        
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        
    Case "ELLIPSE"
        X1 = BdDXF.Entite(Depart).Donnee(0).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        X2 = BdDXF.Entite(Depart).Donnee(2).Valeur
        Y2 = BdDXF.Entite(Depart).Donnee(3).Valeur
        Ratio = BdDXF.Entite(Depart).Donnee(4).Valeur
        Angle1 = BdDXF.Entite(Depart).Donnee(5).Valeur
        Angle2 = BdDXF.Entite(Depart).Donnee(6).Valeur
        X1 = X1 * EchelleX
        Y1 = Y1 * EchelleY
        X2 = X2 * EchelleX
        Y2 = Y2 * EchelleY
        If Angle <> 0 Then
            X3 = RotationX(X1, Y1, Angle)
            Y3 = RotationY(X1, Y1, Angle)
            X1 = X3
            Y1 = Y3
            X3 = RotationX(X2, Y2, Angle)
            Y3 = RotationY(X2, Y2, Angle)
            X2 = X3
            Y2 = Y3
        End If
        If EchelleX < 0 Or EchelleY < 0 Then Ratio = -Ratio ' L'ELLIPSE est inverse
        X1 = X1 + cX
        Y1 = Y1 + cY
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
    
    Case "POLYLINE"
        ' Une POLYLINE est une suite de ligne lie entre elles
        PCount = 1
        EndPoly = False
        Do While Not EndPoly
            X1 = BdDXF.Entite(Depart + PCount).Donnee(0).Valeur
            Y1 = BdDXF.Entite(Depart + PCount).Donnee(1).Valeur
            X2 = BdDXF.Entite(Depart + PCount + 1).Donnee(0).Valeur
            Y2 = BdDXF.Entite(Depart + PCount + 1).Donnee(1).Valeur
            'Facteur d'chelle  des entites selon leur origine
            X1 = X1 * EchelleX
            X2 = X2 * EchelleX
            Y1 = Y1 * EchelleY
            Y2 = Y2 * EchelleY
            'Rotation des entites selon leur origine
            If Angle <> 0 Then
                X3 = RotationX(X1, Y1, Angle)
                Y3 = RotationY(X1, Y1, Angle)
                X1 = X3
                Y1 = Y3
                X3 = RotationX(X2, Y2, Angle)
                Y3 = RotationY(X2, Y2, Angle)
                X2 = X3
                Y2 = Y3
            End If
            'Dplace l'origine
            X1 = X1 + cX
            Y1 = Y1 + cY
            X2 = X2 + cX
            Y2 = Y2 + cY

        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        Call minmax(PoMini, PoMaxi, X2, Y2)
        
            PCount = PCount + 1
            If Depart + PCount + 1 > UBound(BdDXF.Entite) Then
                EndPoly = True
            ElseIf BdDXF.Entite(Depart + PCount + 1).Type <> "VERTEX" Then
                EndPoly = True
            End If
        Loop
        
    Case "TEXT"
        'pas de facteur d'chelle pour le TEXTE
        X1 = BdDXF.Entite(Depart).Donnee(0).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        Size = BdDXF.Entite(Depart).Donnee(2).Valeur
        Angle1 = BdDXF.Entite(Depart).Donnee(3).Valeur + Angle
        Text = BdDXF.Entite(Depart).Donnee(4).Valeur
        'Dplace l'origine
        X1 = X1 + cX
        Y1 = Y1 + cY
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        
    Case "INSERT"
        'Just a note: Block can not be "Stretched" but if they are mirrored . . that
        'shows up in the "scale" Variable for Block
        Nom = BdDXF.Entite(Depart).Donnee(0).Valeur
        X1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(2).Valeur
        X2 = BdDXF.Entite(Depart).Donnee(3).Valeur
        Y2 = BdDXF.Entite(Depart).Donnee(4).Valeur
        '"0" scale = scale of "1"
        If X2 = 0 Then X2 = 1
        If Y2 = 0 Then Y2 = 1
        Angle1 = BdDXF.Entite(Depart).Donnee(5).Valeur * PI / 180
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
        
    Case "DIMENSION"
        'Just a note: Block can not be "Stretched" but if they are mirrored . . that
        'shows up in the "scale" Variable for Block
        Nom = BdDXF.Entite(Depart).Donnee(0).Valeur
        X1 = BdDXF.Entite(Depart).Donnee(1).Valeur
        Y1 = BdDXF.Entite(Depart).Donnee(2).Valeur
        'Test le Maxi et mini pour les zooms
        Call minmax(PoMini, PoMaxi, X1, Y1)
End Select

Next Depart

End Sub
Private Sub VisuDxf_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    DragX = X
    DragY = Y

    
    If optMouse(0) Then Deplace = True
    If optMouse(1) And Zoom = False Then
        Zoom = True
        SelGroup.X1 = X
        SelGroup.Y1 = Y
        SelGroup.X2 = X
        SelGroup.Y2 = Y
    End If
    
End Sub


Private Sub VisuDxf_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
'Affiche les coordonnes
Me.Caption = "DXF Visualisateur -- (" & Format(X, "0.000") & "," & Format(-Y, "0.000") & ")"
If Deplace Then
    VisuDXF.ScaleTop = VisuDXF.ScaleTop + (DragY - Y)
    VisuDXF.ScaleLeft = VisuDXF.ScaleLeft + (DragX - X)
    VisuDXF.Cls
    VisuDXF.Picture = LoadPicture()
    ReAfficheDXF
    Exit Sub
End If
' Mode zoom dessine une fenetre matrialisant la zone de Zoom
If Zoom Then
    VisuDXF.DrawMode = 6
    VisuDXF.DrawStyle = 1
    VisuDXF.DrawWidth = 1
    VisuDXF.Line (SelGroup.X1, SelGroup.Y1)-(SelGroup.X2, SelGroup.Y2), vbBlack, B
    VisuDXF.Line (SelGroup.X1, SelGroup.Y1)-(X, Y), vbBlack, B
    SelGroup.X2 = X
    SelGroup.Y2 = Y
End If
End Sub


Private Sub VisuDxf_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim A As Double
Dim B As Double
Dim C As Double
Dim D As Double

DoEvents
VisuDXF.DrawMode = 13
VisuDXF.DrawStyle = 0
VisuDXF.DrawWidth = 1
If Zoom Then
    If SelGroup.X2 < SelGroup.X1 Then Intervertir SelGroup.X1, SelGroup.X2
    If SelGroup.Y2 < SelGroup.Y1 Then Intervertir SelGroup.Y1, SelGroup.Y2
    SelGroup.Y2 = SelGroup.Y1 + Abs(SelGroup.X2 - SelGroup.X1)
    If SelGroup.X2 = SelGroup.X1 Then
        Exit Sub
    End If
    If SelGroup.Y2 = SelGroup.Y1 Then
        Exit Sub
    End If
    
C = Abs(SelGroup.X2 - SelGroup.X1)
D = Abs(SelGroup.Y1 - SelGroup.Y2)
If C > D Then
A = C
Else
A = D
End If

B = VisuDXF.Height / VisuDXF.Width

    'VisuDXF.ScaleWidth = A
    'VisuDXF.ScaleLeft = P1.X - 15
    'VisuDXF.ScaleHeight = A * B
    'VisuDXF.ScaleTop = -P2.Y - 15
    
    VisuDXF.ScaleWidth = A 'Abs(SelGroup.X2 - SelGroup.X1)
    VisuDXF.ScaleLeft = SelGroup.X1
    VisuDXF.ScaleHeight = A * B ' Abs(SelGroup.Y1 - SelGroup.Y2)
    VisuDXF.ScaleTop = SelGroup.Y1
    ReAfficheDXF
End If
Deplace = False
Zoom = False


End Sub

' Si l'on click sur un layer dans l'arbre d'affichage seul le layer s'lectionn devient visible
Private Sub TreeViewLayer_NodeClick(ByVal Node As MSComctlLib.Node)
If Node.Index = 1 Then
    ReAfficheDXF ("")
Else
    ReAfficheDXF (Node.Text)
End If
End Sub





